diff --git a/Tmain/delayed-error.d/exit-expected.txt b/Tmain/delayed-error.d/exit-expected.txt
new file mode 100644
index 0000000000..573541ac97
--- /dev/null
+++ b/Tmain/delayed-error.d/exit-expected.txt
@@ -0,0 +1 @@
+0
diff --git a/Tmain/delayed-error.d/input.c b/Tmain/delayed-error.d/input.c
new file mode 100644
index 0000000000..6d1a0d47b7
--- /dev/null
+++ b/Tmain/delayed-error.d/input.c
@@ -0,0 +1 @@
+int x;
diff --git a/Tmain/delayed-error.d/run.sh b/Tmain/delayed-error.d/run.sh
new file mode 100644
index 0000000000..ee6655ff2e
--- /dev/null
+++ b/Tmain/delayed-error.d/run.sh
@@ -0,0 +1,18 @@
+# Copyright: 2021 Masatake YAMATO
+# License: GPL-2
+
+CTAGS=$1
+
+printf "%s" "--version..."
+if ! ${CTAGS} --quiet --options=NONE --langdef=C -o - --version > /dev/null; then
+   exit 1
+fi
+echo "ok"
+
+printf "%s" "input.c..."
+if ${CTAGS} --quiet --options=NONE --langdef=C -o - input.c > /dev/null; then
+   exit 1
+fi
+echo "ok"
+
+exit 0
diff --git a/Tmain/delayed-error.d/stderr-expected.txt b/Tmain/delayed-error.d/stderr-expected.txt
new file mode 100644
index 0000000000..b7c553a1a2
--- /dev/null
+++ b/Tmain/delayed-error.d/stderr-expected.txt
@@ -0,0 +1 @@
+ctags: Language "C" already defined
diff --git a/Tmain/delayed-error.d/stdout-expected.txt b/Tmain/delayed-error.d/stdout-expected.txt
new file mode 100644
index 0000000000..a4a79e8ed7
--- /dev/null
+++ b/Tmain/delayed-error.d/stdout-expected.txt
@@ -0,0 +1,2 @@
+--version...ok
+input.c...ok
diff --git a/main/error.c b/main/error.c
index 13213da016..f21f2493e1 100644
--- a/main/error.c
+++ b/main/error.c
@@ -51,6 +51,49 @@ extern bool stderrDefaultErrorPrinter (const errorSelection selection,
 	return (selected (selection, FATAL) || Option.fatalWarnings)? true: false;
 }
 
+struct delayedMsg {
+	errorSelection selection;
+	vString *msg;
+};
+
+static ptrArray *delayedMsgQueue;
+
+static void deleteDelayedMsg (void *data)
+{
+	struct delayedMsg *dmsg = data;
+	vStringDelete (dmsg->msg);
+	eFree (dmsg);
+}
+
+extern void flushDelayedMsgQeueue (void)
+{
+	if (!delayedMsgQueue)
+		return;
+
+	for (unsigned int i = 0; i < ptrArrayCount (delayedMsgQueue); i++)
+	{
+		struct delayedMsg *dmesg = ptrArrayItem (delayedMsgQueue, i);
+		error (dmesg->selection, "%s", vStringValue (dmesg->msg));
+	}
+
+	ptrArrayDelete (delayedMsgQueue);
+	delayedMsgQueue = NULL;
+}
+
+static bool queueDelayedMsg (const errorSelection selection,
+							 const char *const format, va_list ap)
+{
+	if (delayedMsgQueue == NULL)
+		delayedMsgQueue = ptrArrayNew (deleteDelayedMsg);
+
+	struct delayedMsg *dmsg = xMalloc (1, struct delayedMsg);
+	dmsg->selection = (selection & ~DELAYED);
+	dmsg->msg = vStringNewVPrintf (format, ap);
+
+	ptrArrayAdd (delayedMsgQueue, dmsg);
+	return false;
+}
+
 extern void error (const errorSelection selection,
 		   const char *const format, ...)
 {
@@ -61,7 +104,10 @@ extern void error (const errorSelection selection,
 		return;
 
 	va_start (ap, format);
-	shouldExit = (* errorPrinter) (selection, format, ap, errorPrinterData);
+	if (selected (selection, DELAYED))
+		shouldExit = queueDelayedMsg (selection, format, ap);
+	else
+		shouldExit = (* errorPrinter) (selection, format, ap, errorPrinterData);
 	va_end (ap);
 
 	if (shouldExit)
diff --git a/main/options.c b/main/options.c
index 1ca8ae06f5..2ff1d5b5b8 100644
--- a/main/options.c
+++ b/main/options.c
@@ -748,6 +748,8 @@ extern bool filesRequired (void)
 
 extern void checkOptions (void)
 {
+	flushDelayedMsgQeueue();
+
 	const char* notice;
 	if (Option.xref && (Option.customXfmt == NULL))
 	{
diff --git a/main/parse.c b/main/parse.c
index 2306e386f6..82f7c33b8d 100644
--- a/main/parse.c
+++ b/main/parse.c
@@ -2358,10 +2358,7 @@ extern void processLanguageDefineOption (
 		error (FATAL, "No language specified for \"%s\" option", option);
 	}
 	else if (getNamedLanguage (name, 0) != LANG_IGNORE)
-	{
-		/* name cannot be freed because it is used in the FATAL message. */
-		error (FATAL, "Language \"%s\" already defined", name);
-	}
+		error (FATAL|DELAYED, "Language \"%s\" already defined", name);
 	else if (strcmp(name, RSV_LANG_ALL) == 0)
 	{
 		eFree (name);
diff --git a/main/routines.h b/main/routines.h
index a95ef01015..e8d1ec4369 100644
--- a/main/routines.h
+++ b/main/routines.h
@@ -34,7 +34,13 @@
 *   DATA DECLARATIONS
 */
 typedef int errorSelection;
-enum eErrorTypes { FATAL = 1, WARNING = 2, NOTICE = 4, PERROR = 8, };
+enum eErrorTypes {
+	FATAL   = 1 << 0,
+	WARNING = 1 << 1,
+	NOTICE  = 1 << 2,
+	PERROR  = 1 << 3,
+	DELAYED = 1 << 4,
+};
 
 /*
 *   FUNCTION PROTOTYPES
@@ -42,6 +48,8 @@ enum eErrorTypes { FATAL = 1, WARNING = 2, NOTICE = 4, PERROR = 8, };
 extern void error (const errorSelection selection, const char *const format, ...) CTAGS_ATTR_PRINTF (2, 3);
 #define notice(...) error (NOTICE, __VA_ARGS__)
 
+extern void flushDelayedMsgQeueue (void);
+
 /* Memory allocation functions */
 #ifdef NEED_PROTO_MALLOC
 extern void *malloc (size_t);
